/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - April 1, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca> (limited to first 2 functions)
   -
*/

////////////////////////////////////////////////////////////////////////////////
function defineShortURL(aURI)
{
  try {
    var i = aURI.indexOf(":");
  } 
  catch(ex) {
    return aURI;
  }
  if (i != -1) {
    while(!isAlphaNum(aURI[i]))
      i++;
    return aURI.substring(i, aURI.length);
  }
  return aURI;
}
////////////////////////////////////////////////////////////////////////////////
function isAlphaNum(mixedCase)
{
  var allCaps = mixedCase.toUpperCase();
  for (var i = allCaps.length - 1; i >= 0; i--) {
    var c = allCaps.charAt(i);
    if ((c < 'A' || c > 'Z') && (c < '0' || c > '9') && (c!='_'))
      return false;
  }
  return true;
}
////////////////////////////////////////////////////////////////////////////////
function getLocationFromClipboard()
{
  var URL = null;
  var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"]
                            .getService(Components.interfaces.nsIClipboard);
  var trans = Components.classes["@mozilla.org/widget/transferable;1"]
                        .createInstance(Components.interfaces.nsITransferable);
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);

  try {
    trans.addDataFlavor("text/unicode");
    clipboard.getData(trans, clipboard.kGlobalClipboard);

    var data = {};
    var dataLen = {};
    trans.getTransferData("text/unicode", data, dataLen);

    if (data) {
      data = data.value.QueryInterface(Components.interfaces.nsISupportsString);
      data = data.data.substring(0, dataLen.value / 2);
      // Convert clipboard data to URL
      try {
        var URI = ioService.newURI(data, null, null);
        URL = URI.spec;
      } catch(ex) {
        alert(mzGetTextFromBundle("noValidClipboardURL"));
      }
    }
    else {
      alert(mzGetTextFromBundle("noClipboardData"));
    }
  } catch (ex) {
    alert(mzGetTextFromBundle("clipboardReadError"));
  }
  return URL;
}
////////////////////////////////////////////////////////////////////////////////
function displayVersion()
{
  var mVersion = getBrowser().mVersion;
  var mVersionRev = getBrowser().mVersionRev;

  window.openDialog("chrome://multiviews/content/multiviewsAbout.xul", "multiviewsClose", 
                    "chrome,dialog,dependent",(mVersion+mVersionRev),loadURI);
}
////////////////////////////////////////////////////////////////////////////////
// This function collects version/revision info and builds the following URL:
// http://multizilla.mozdev.org/update.html?version=1.6.0.1&revision=e&gb-version=1.4&gb-revision=c
////////////////////////////////////////////////////////////////////////////////
function doCheck4Updates()
{
  var URL = "http://multizilla.mozdev.org/update.html?version=";
  var mzVersionInfo = getBrowser().mVersion + "&revision=" + getBrowser().mVersionRev;
  var gbVersionInfo = "";

  if (mzToolbox.mToolboxActivated) { // GoogleBox installed?
    var googleBox = document.getElementById("internalToolBox");
    // Pre GoogleBox v1.4a versions had no version info, that's why we check for 'undefined'
    var googleBoxVersion = (googleBox.mVersion == undefined) ? 0 : googleBox.mVersion;
    var googleBoxRevision = (googleBox.mVersionRev == undefined) ? "" : googleBox.mVersionRev;
    gbVersionInfo = "&gb-version=" + googleBoxVersion + "&gb-revision=" + googleBoxRevision;
  }
  getBrowser().selectedTab = getBrowser().addTab(URL + mzVersionInfo + gbVersionInfo, null);
}
////////////////////////////////////////////////////////////////////////////////
function validateThisPage(aURL)
{
  if (aURL) {
    var IOService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    if (!IOService)
       return;
    var scheme = "";

    try {
      scheme = IOService.extractScheme(aURL, {schemeStartPos:0}, {schemeEndPos:0});
    } catch(ex) { 
      alert(mzGetTextFromBundle('errorText'));
    }
    if (scheme == "http") {
      var checkURL = "http://validator.w3.org/check?uri=" + aURL + 
                     "&charset=%28detect+automatically%29&doctype=Inline";
      getBrowser().addTab(checkURL, null);
    }
    else {
      alert(mzGetTextFromBundle('unsupportedProtocolForValidator', [scheme]));
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function handlePTFolders(node)
{
  if (!node.hasChildNodes())
    return; // no folder, bail out
  var personalToolbar = node.parentNode;
  // 'hbox' for folders and 'toolbox' for the Bookmarks button 
  if (personalToolbar.nodeName == "hbox")
    personalToolbar = personalToolbar.parentNode;
  if ("lastPopup" in personalToolbar && personalToolbar.lastPopup != null) {
    node = node.firstChild;
    if (node.nodeName == "menupopup") {
      if (personalToolbar.lastPopup != null)
        personalToolbar.lastPopup.hidePopup();
      node.showPopup(node);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function initViewMenu(aMenupopup)
{
  // XXX: Total HACK to remove the original menu items
  var i = 0;
  var removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewpersonaltoolbar"); 
  initGoogleBoxMenuitem("GoogleBoxShowHideMenuitem");

  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewnavbar");
  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  initToolbarsMenu();
}
//////////////////////////////////////////////////////////////////////////
// The following five functions are GoogleBox specific functions
//////////////////////////////////////////////////////////////////////////
function aboutGooglebox()
{
  if (isGoogleBoxInstalled()) {
    alert(document.getElementById("internalToolBox").mVersionInfo);
  }
}
//////////////////////////////////////////////////////////////////////////
function isGoogleBoxInstalled(aStartupFlag)
{
  // We should also check the menu items in QPrefs Extension Manager!!!
  if (!mzToolbox.mToolboxActivated) {
    if (!aStartupFlag)
      gBrowser.selectedTab = gBrowser.addTab("http://multizilla.mozdev.org/features/googlebox.html");
    return false;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////
function initGoogleBoxMenuitem(aMenuitem)
{
  var enabled = readMyPref('multizilla.integrated.toolbar', 'bool', false);

  if (!enabled || mzToolbox.mPlaceHolder.getAttribute("hidden") == "true" || 
      document.getElementById('MultiZillaToolbar').getAttribute('hidden') == "true")
    document.getElementById(aMenuitem).removeAttribute("checked");
  else
    document.getElementById(aMenuitem).setAttribute("checked", "true");
}
//////////////////////////////////////////////////////////////////////////
function toggleOrEnableGoogleBox(aStartupFlag)
{
  if (!isGoogleBoxInstalled(aStartupFlag))
    return;

  var checkboxText = null;
  var enabled = readMyPref('multizilla.integrated.toolbar', 'bool', false);
  var notify = readMyPref('multizilla.integrated.toolbar-notify', 'bool', true);

  if (!notify && aStartupFlag)
    return;

  if (!enabled) {
    var promptService = Components.classes['@mozilla.org/embedcomp/prompt-service;1']
                                  .getService(Components.interfaces.nsIPromptService);

    var title = mzGetTextFromBundle('mzWizard');
    var text = mzGetTextFromBundle('enableGoogleBoxText');
    var checkbox = {value:0};

    if (aStartupFlag)
      checkboxText = mzGetTextFromBundle('rememberDecisionText');

    var result = promptService.confirmEx(window, title, text, 
                                        (promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_YES) +
                                        (promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_NO),
                                         null, null, null, checkboxText, checkbox);

    if (checkbox.value) {
      writePref('bool', 'multizilla.integrated.toolbar-notify', false);
      return;
    }
    if (result == 1)
      return;
    writePref('bool', 'multizilla.integrated.toolbar', true);
    return;
  }
  updateGoogleBoxState(true, false);
  mzToolbox.refreshMultiZillaButtons();
}
//////////////////////////////////////////////////////////////////////////
function updateGoogleBoxState(aState, aSkipFlag)
{
  if (aState && document.getElementById('MultiZillaToolbar').getAttribute('hidden') == "true") {
    if (document.getElementById('internalToolBox').getAttribute('hidden') != "true") {
      goToggleToolbar('MultiZillaToolbar', 'cmd_viewMultiZillaToolbar');
      return;
    }
    goToggleToolbar('MultiZillaToolbar', 'cmd_viewMultiZillaToolbar');
  }
  if (!aSkipFlag)
    goToggleToolbar('internalToolBox', 'cmd_viewIntegratedToolBox')
}
//////////////////////////////////////////////////////////////////////////
function askToDisableButton(aEvent)
{
  aEvent.preventBubble();

  var button = aEvent.target;
  var buttonId = button.getAttribute("id");

  if (buttonId) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);

    if (promptService.confirm(window, mzGetTextFromBundle("disableButtonTitle"), mzGetTextFromBundle("disableButtonText"))) {
      var index = buttonId.indexOf("-");
      var buttonName = buttonId.substring(0, index);
      var observerId = button.getAttribute("observes");

      if (observerId) {
         button.setAttribute("hidden", "true");
         /* var observer = document.getElementById(observerId);
         alert(observer); */
         // observer.setAttribute("disabled", true);
      }
      if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
        writePref("bool", "multizilla.showbutton." + buttonName, false);
      else
        writePref("bool", "browser.toolbars.showbutton." + buttonName, false);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function doHomeButtonClick(aEvent)
{
  if (aEvent.button == 1) {
    var homePage = getHomePage();
    // We don't have to open a new tab for a group
    if (homePage.length == 1) { // single home page set?
      var tabbrowser = getBrowser();
      tabbrowser.selectedTab = tabbrowser.addTab();
    }
    BrowserHome();
  }
  else if (aEvent.button == 2)
    askToDisableButton(event);
}
//////////////////////////////////////////////////////////////////////////
function initButtonContextMenu(aContextMenu, aID)
{
  var buttonIDs = (aID == "NT") ? [ "skip", "skip", "back-button", "forward-button", 
                                    "reload-button", "stop-button", "skip", 
                                    "qpmenu-tbbutton", "clearlocbar-tbbutton", 
                                    "skip", "go-button", "search-button", "print-button" ] : 
                                  [ "skip", "skip", "home-button", "bookmarks-button", 
                                    "qpmenu-button" ];

  for (var i = 0; i < buttonIDs.length; i++) {
    if (buttonIDs[i] != "skip") {
      var button = document.getElementById(buttonIDs[i]);
      var hidden = button.getAttribute("hidden");
      aContextMenu.childNodes[i].setAttribute("checked", (hidden == "true") ? "false" : "true");
    }
  }
  return;
}
//////////////////////////////////////////////////////////////////////////
function doButtonUpdate(aEvent)
{
  var buttonId = aEvent.getAttribute("buttonid");
  var index = buttonId.indexOf("-");
  var buttonName = buttonId.substring(0, index);

  if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
    toggleBoolPref("multizilla.showbutton." + buttonName, "bool", true);
  else
    toggleBoolPref("browser.toolbars.showbutton." + buttonName, "bool", true);
}
//////////////////////////////////////////////////////////////////////////
function overrideContextMenu(aEvent)
{
  if (aEvent.button == 2) {
    var contextMenu = aEvent.target.getAttribute("context-menu");
    var overrideContextPopup = document.getElementById("buttonContextPopup");
    var defaultContextPopup = document.getElementById(contextMenu);
    // Note that attribute popup="" is needed in order to open the context menu at the desired position!
    if (aEvent.ctrlKey) {
      if (defaultContextPopup)
        defaultContextPopup.hidePopup();
      overrideContextPopup.showPopup(overrideContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
    }
    else if (contextMenu) {
      overrideContextPopup.hidePopup();
      defaultContextPopup.showPopup(defaultContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function viewPermissionManager(aType, aHostPort) {
  if (!aType) {
    var defaultType = readMyPref("multizilla.perm-manager.default-manager", "string", "cookieManager");
    aType = defaultType;
  }
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
  var permManagerWindow = windowManager.getMostRecentWindow("multizilla:permissionmanager");

  if (permManagerWindow)
    permManagerWindow.close();

  window.openDialog("chrome://multiviews/content/multiviewsPermissionManager.xul", "_blank", "chrome,resizable=yes", aType, (aHostPort ? aHostPort : ""));
}
////////////////////////////////////////////////////////////////////////////////
function onPrivacyButtonClick(aEvent)
{
  if (aEvent.ctrlKey) {
    if (confirmAction('confirmDialogRemoveAllCookiesTitle', 'confirmDialogRemoveAllCookiesText'))
      mzClearAllCookies();
  }
  else 
    goPreferences('multiviewsPrefCell', 'chrome://multiviews/content/pref/pref-multiviews.xul', 'mzPrivacy');
}
////////////////////////////////////////////////////////////////////////////////
function useFirstPage()
{
 var uriToLoad = null;
  if ("arguments" in window && window.arguments.length >= 1 && window.arguments[0])
    uriToLoad = window.arguments[0];
  if (readMyPref("multizilla.tabs.blank-tab-first", "bool", true)) {
    if ((readMyPref("browser.startup.page", "int", 1) == 1 && 
        getHomePage() == "about:blank" || getHomePage() == "") || uriToLoad == "about:blank" || 
        readMyPref("browser.startup.page", "int", 0) == 3 && uriToLoad == "about:blank")
      return true;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////
// We need to get notified of blocked popup windows. We replace mozilla's 
// 'DOMPopupBlocked' event listener (onPopupBlocked) with our event 
// listener. We call 'onPopupBlocked' when we're done.
//////////////////////////////////////////////////////////////////////////
function mzOnPopupBlocked(aEvent)
{
  var browser = getBrowserForDocument(aEvent.target);
  // Do we need to display the popup icon on the tab?
  if (gPopupIconOnTab && gDelayedPopupIconRemoval > 0) {
    var targetTab = getBrowser().getTabForBrowser(browser);
    targetTab.setAttribute("popup", "true");
  }
  if (aEvent.popupWindowURI) {
    addBlockedWindowToMenu(browser, aEvent.popupWindowURI.spec, null);
  }
  else if (readMyPref("multizilla.window-open.display-failures", "bool", false)) {
    alert("Warning: Mozilla failed to initialize 'popupWindowURI'\n\nPlease install a more recent version of mozilla (when available).")
  }
  browser.mNumberOfBlockedWindows++;
  onPopupBlocked(aEvent); // we're done, call mozilla's listener
}
//////////////////////////////////////////////////////////////////////////
// This will add the URL of the blocked popup window to the list and also 
// enables the icon/menu popup on the status bar.
//////////////////////////////////////////////////////////////////////////
function addBlockedWindowToMenu(aBrowser, aBlockedURL, aPopupObject)
{
  if (!aBlockedURL) {
    if (!aPopupObject) {
      return;
     }
     else
      aBlockedURL = aPopupObject.url;
  }
  for (i in aBrowser.mBlockedWindows) {
    if (aBlockedURL == aBrowser.mBlockedWindows[i].url)
      return;
  }
  if (!aPopupObject) {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var blockedURI = ioService.newURI(aBlockedURL, null, null);
    var popupObject = new Object();
    // Note to self: test your modifications with: file, http, https and about (last one is important)
    var validScheme = aBlockedURL.match(/(http:|https:)/i);
    popupObject.hostPort = validScheme ? blockedURI.hostPort : aBlockedURL.match(/file:/i) ? 'file:' : aBlockedURL;
    popupObject.url = aBlockedURL;
    popupObject.name = '_blank';
    popupObject.features = '';
    popupObject.referrer = blockedURI;
    aPopupObject = popupObject;
  }
  aBrowser.mBlockedWindows.push(aPopupObject);

  if (aBrowser.mBlockedWindows.length > 15)
    aBrowser.mBlockedWindows.splice(0, 1);
  if (aBrowser == getBrowser().mCurrentBrowser) {
    var button = document.getElementById("blocked-window-button");
    button.setAttribute("blocked", "true");
  }
}
//////////////////////////////////////////////////////////////////////////
// This will add menu items to the blocked window menu on the status bar
//////////////////////////////////////////////////////////////////////////
function buildBlockedPopupWindowMenu(aParent)
{
  deleteHistoryItems(aParent);
  var tabbrowser = getBrowser();
  var counter = tabbrowser.mCurrentBrowser.mBlockedWindows.length;

  for (var i = 0; i < counter; i++) {
    var menuitem = document.createElement("menuitem");
    // A site can open more than one new window, what 'label' do we want in that case?
    menuitem.setAttribute("label", tabbrowser.mCurrentBrowser.mBlockedWindows[i].hostPort);
    menuitem.setAttribute("url", tabbrowser.mCurrentBrowser.mBlockedWindows[i].url);
    menuitem.setAttribute("name", tabbrowser.mCurrentBrowser.mBlockedWindows[i].name);
    menuitem.setAttribute("features", tabbrowser.mCurrentBrowser.mBlockedWindows[i].features);
    menuitem.referrer = tabbrowser.mCurrentBrowser.mBlockedWindows[i].referrer;
    menuitem.setAttribute("index", i); // make deleteHistoryItems() work
    aParent.appendChild(menuitem);
  }
}
//////////////////////////////////////////////////////////////////////////
// This allows you to open the blocked window in a new Tab or new Window
//////////////////////////////////////////////////////////////////////////
function openBlockedWindow(aEvent)
{
  var menuitem = aEvent.originalTarget;
  var URL = menuitem.getAttribute("url");
  var name = menuitem.getAttribute("name");
  var features = menuitem.getAttribute("features");
  var referrer = menuitem.referrer;
  var charset = 'charset=' + window.document.characterSet;
  
  if (URL == "about:blank" || URL == "")
    return;
  if (aEvent.ctrlKey) {
    // TODO: check for possible missing window features/flags
    features = (aEvent.shiftKey) ? "" : "resizable=yes,minimizable=yes,close=yes," + features;
    window.open(URL, name, features, charset, referrer);
  }
  else {
    var tabbrowser = getBrowser();
    tabbrowser.selectedTab = tabbrowser.addTab(URL, referrer, charset, null, name);
  }
}
//////////////////////////////////////////////////////////////////////////
// This updates the number of blocked windows in the tooltip
//////////////////////////////////////////////////////////////////////////
function updateBlockedWindowTooltip()
{
  var blockedWindowButton = document.getElementById("blocked-window-button");
  var browser = gBrowser.getBrowserForTab(gBrowser.selectedTab);
  var tooltipText = mzGetTextFromBundle("blockedWindowButton.tooltip", [browser.mNumberOfBlockedWindows], null);
  blockedWindowButton.setAttribute("tooltiptext", tooltipText);
}
//////////////////////////////////////////////////////////////////////////
function initBlockedWindowTooltip(aTooltipNode, aMenuitem)
{
  var node = aTooltipNode.firstChild;
  node.childNodes[0].setAttribute("value", mzGetTextFromBundle('URL') + " " + aMenuitem.getAttribute("url"));
  node.childNodes[1].setAttribute("value", mzGetTextFromBundle('Target') + " " + aMenuitem.getAttribute("name"));
  var referrer = aMenuitem.referrer;
  node.childNodes[2].setAttribute("value", mzGetTextFromBundle('Referrer') + " " + (referrer ? referrer.spec : "undefined"));
}
//////////////////////////////////////////////////////////////////////////
function isHostBlocked(aBrowser, aHost)
{
  for (i in aBrowser.mBlockedWindows) {
    if (aBrowser.mBlockedWindows[i].hostPort == aHost)
      return true;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////
function toJavaScriptConsole() {
  toOpenWindowByType("global:console", "chrome://multiviews/content/js-console/console.xul");
}


