/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  Rajnish Bhaskar <raj@lordofthemoon.com>
   -
   -
*/

///////////////////////////////////////////////////////////////////////////////
// Check if we are running stand-alone or as MultiZilla client
///////////////////////////////////////////////////////////////////////////////
function isMultiZillaRunning()
{
  var mzToolbar = document.getElementById("MultiZillaToolbar");
  if (mzToolbar)
    return mzToolbar;
  else return null;
}
///////////////////////////////////////////////////////////////////////////////
function initQPMmenu(qpmPopupMenu)
{
  var i = 0;
  var mzToolbar = isMultiZillaRunning();
  var menuItems = qpmPopupMenu.getElementsByAttribute("display", "hidden-tabbar");

  if (mzToolbar && mzToolbar.getAttribute("hidden") == "true") {
    for (i = 0; i < menuItems.length; i++)
      menuItems[i].removeAttribute("hidden");
    return;
  }
  // Hide extra menu items for stand-alone QPM and when the MultiZilla Toolbar is hidden!
  for (i = 0; i < menuItems.length; i++)
    menuItems[i].setAttribute("hidden", "true");
}
///////////////////////////////////////////////////////////////////////////////
function initGroupPref(menuElement)
{
  var prefGroup = menuElement.getAttribute("prefgroup");
  var prefElements = document.getElementsByAttribute("prefgroup", prefGroup);

  if (prefElements.length == 0)
    return;

  var prefType = prefElements[1].getAttribute("preftype");
  var prefDefval = prefElements[1].getAttribute("prefdefval");
  var prefIdentifier = prefElements[1].getAttribute("prefstring");
  var prefDefaultFlag = true;
  var prefValue = readMyPref(prefIdentifier, prefType, 0, prefDefaultFlag);

  for (var i = 1; i < prefElements.length; i++) {
    if (prefElements[i].getAttribute("prefvalue") == prefValue)
      prefElements[i].setAttribute("checked", "true");       
    else
      prefElements[i].removeAttribute("checked");
  }
}
////////////////////////////////////////////////////////////////////////////////
function changePref(menuElement, menuGroup, doRefresh)
{
  var prefType = menuElement.getAttribute("preftype");
  var prefIdentifier = menuElement.getAttribute("prefstring");
  var prefDefval = menuElement.getAttribute("prefdefval");
  var prefAttribute = null;
  var prefArray = new Array();
  var noAccess = "noAccess";
  var allAccess = "allAccess";
	
  if (prefIdentifier != null) {
    // retrieve current value
    var prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefType == "bool") // flip flop the pref
      writePref(prefType, prefIdentifier, !prefValue);
    else {
      if (menuGroup) // special case, use this value
        prefValue = menuElement.getAttribute("prefvalue");
      else { // used for int and string, other might follow
        prefAttribute = menuElement.getAttribute("prefattribute");

        if (prefAttribute == "checked") {
          // setup an array with values to use
          prefValues = eval(menuElement.getAttribute("prefvalue"));
	        prefArray = prefValues;
          // pick the first or second value, based on the "checked" state
          prefValue = menuElement.getAttribute(prefAttribute) ? prefArray[1] : prefArray[0];
        }
        else
          prefValue = menuElement.getAttribute(prefAttribute);
      }
      // Ok, lets write this sucker
      writePref(prefType, prefIdentifier, prefValue);
    }
    if (doRefresh) // this pref setting needs a refresh
      getWebNavigation().reload(nsIWebNavigation.LOAD_FLAGS_IS_REFRESH);
  }
}
////////////////////////////////////////////////////////////////////////////////
function initQuickPrefs()
{
  var prefElements = document.getElementsByAttribute("pref", "true");

  for (var i = 0; i < prefElements.length; i++) {
    var prefId = prefElements[i].getAttribute("id");
    var prefType = prefElements[i].getAttribute("preftype");
    var prefIdentifier = prefElements[i].getAttribute("prefstring");
    var prefDefval = prefElements[i].getAttribute("prefdefval");
    var prefAttribute = prefElements[i].getAttribute("prefattribute");
    var prefValue;

    prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefAttribute == "checked") {
      if (prefValue >= 1)
        prefElements[i].setAttribute(prefAttribute, "true");
      else prefElements[i].removeAttribute(prefAttribute);
    }
    else 
      prefElements[i].setAttribute(prefAttribute, prefValue);
  }
}
////////////////////////////////////////////////////////////////////////////////
// this code is copied from cookieNavigatorOverlay.xul and changed accordantly
// and it is always available for the end-user. We don't check the pref :-)
////////////////////////////////////////////////////////////////////////////////
function initSelectedQPrefsMenu(aPopupType)
{
  permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"]
                                .getService(Components.interfaces.nsIPermissionManager);
  popupmanager = Components.classes["@mozilla.org/PopupWindowManager;1"]
                           .getService(Components.interfaces.nsIPopupWindowManager);
  var permission, url;
  var uri = getBrowser().currentURI;

  if (gBrowser.selectedTab.hasAttribute("busy"))
    url = gBrowser.mCurrentTab.getAttribute("firstPage");
  else 
    url = gBrowser.mCurrentBrowser.webNavigation.currentURI.spec;

  if (aPopupType == "cookies") {
    permission = permissionmanager.testPermission(uri, "cookie");
    mzEnableElement("qpm_BlockCookies", url, (permission == nsIPermissionManager.DENY_ACTION),
                    permission != nsIPermissionManager.DENY_ACTION);
    mzEnableElement("qpm_AllowCookies", url, (permission == nsIPermissionManager.ALLOW_ACTION),
                    permission != nsIPermissionManager.ALLOW_ACTION);
    mzEnableElement("qpm_DefaultCookies", url, (permission == nsIPermissionManager.UNKNOWN_ACTION),
                    permission != nsIPermissionManager.UNKNOWN_ACTION);
    mzEnableElement("qpm_CookiesSeparator", url, false, true);

    var managePrivacySettings = document.getElementById("qpm_ManageCookiesPrivacySettings");

    if (readMyPref("network.cookie.cookieBehavior", "int", 3) == 3)
      managePrivacySettings.removeAttribute("hidden");
    else 
      managePrivacySettings.setAttribute("hidden", "true");
  }
  else if (aPopupType == "images") {
    permission = permissionmanager.testPermission(uri, "image");
    mzEnableElement("qpm_BlockImages", url, (permission == nsIPermissionManager.DENY_ACTION),
                    permission != nsIPermissionManager.DENY_ACTION);
    mzEnableElement("qpm_AllowImages", url, (permission == nsIPermissionManager.ALLOW_ACTION),
                    permission != nsIPermissionManager.ALLOW_ACTION);
    mzEnableElement("qpm_DefaultImages", url, (permission == nsIPermissionManager.UNKNOWN_ACTION),
                    permission != nsIPermissionManager.UNKNOWN_ACTION);
    mzEnableElement("qpm_ImageSeparator", url, false, true);
  }
  else if (aPopupType == "popups") {
    permission = nsIPermissionManager.UNKNOWN_ACTION;
    permission = permissionmanager.testPermission(uri, "popup");
    mzEnableElement("qpm_AllowPopups", url, (permission == nsIPermissionManager.DENY_ACTION),
                    permission != nsIPermissionManager.ALLOW_ACTION)
    mzEnableElement("qpm_BlockPopups", url, (permission == nsIPermissionManager.ALLOW_ACTION),
                    permission != nsIPermissionManager.DENY_ACTION);
    mzEnableElement("qpm_DefaultPopups", url, (permission == nsIPermissionManager.UNKNOWN_ACTION),
                    permission != nsIPermissionManager.UNKNOWN_ACTION);
    mzEnableElement("qpm_PopupsSeparator", url, false, true);
  }
  else if (aPopupType == "object") {
    permission = nsIPermissionManager.UNKNOWN_ACTION;
    permission = permissionmanager.testPermission(uri, "object");
    mzEnableElement("qpm_AllowPlugin", url, (permission == nsIPermissionManager.DENY_ACTION),
                    permission != nsIPermissionManager.ALLOW_ACTION)
    mzEnableElement("qpm_BlockPlugin", url, (permission == nsIPermissionManager.ALLOW_ACTION),
                    permission != nsIPermissionManager.DENY_ACTION);
    mzEnableElement("qpm_DefaultPlugin", url, (permission == nsIPermissionManager.UNKNOWN_ACTION),
                    permission != nsIPermissionManager.UNKNOWN_ACTION);
    mzEnableElement("qpm_PluginSeparator", url, false, true);
  }
}
///////////////////////////////////////////////////////////////////////////////
// This is a rewrite of enableElement() in cookieNavigatorOverlay.xul
// All elements will be disabled for new (blank) tabs
///////////////////////////////////////////////////////////////////////////////
function mzEnableElement(elementID, url, current, enabled)
{
  var element = document.getElementById(elementID);
  element.setAttribute("currentPermission", current ? "true" : "false");

  if (enabled && url != "about:blank")
    element.removeAttribute("disabled");
  else
    element.setAttribute("disabled", "true");
}
///////////////////////////////////////////////////////////////////////////////
// This is a rewrite of aCookieImageAction() in cookieNavigatorOverlay.xul 
////////////////////////////////////////////////////////////////////////////////
function aCIPAction(element)
{
  var permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"].getService(Components.interfaces.nsIPermissionManager);
  var action = element.getAttribute("for")
  var uri = getBrowser().currentURI;
  var permission = element.getAttribute("permission");

  if (permission == "none")
    permission = nsIPermissionManager.UNKNOWN_ACTION;
  else 
    permission = (element.getAttribute("permission") == "true") ? nsIPermissionManager.ALLOW_ACTION : nsIPermissionManager.DENY_ACTION;

  switch (action) {
    case "qpm_CookieAction":
      permissionmanager.add(uri, "cookie", permission);
      break;
    case "qpm_ImageAction":
      permissionmanager.add(uri, "image", permission);
      break;
    case "qpm_PopupAction":
      permissionmanager.add(uri, "popup", permission);
      break;
  }
  alert(element.getAttribute("msg"));
}
////////////////////////////////////////////////////////////////////////////////
function initUserAgentMenu(aParent)
{
  /* var items = aParent.childNodes.length;
  dump("\n"+items);
  if (items == 6) {
    aParent.database.AddDataSource(mzRDFStore);
  }
  else if (items > 6) {
    for (var i = 7; i < items; i++)
      aParent.removeChild(aParent.childNodes[i]);
  } */
  aParent.database.RemoveDataSource(mzRDFStore);
  aParent.builder.rebuild();
  aParent.database.AddDataSource(mzRDFStore);
  aParent.builder.rebuild();
  reinitUserAgentMenu(aParent);
}
////////////////////////////////////////////////////////////////////////////////
function reinitUserAgentMenu(aParent)
{
  if (aParent.childNodes.length == 6) { // 4
    // Display 'Learn to setup a custom UserAgent ...' menu item
    aParent.childNodes[4].removeAttribute("hidden"); // 2
  }
  else {
    var overrideUA = null;
    var override = false;
    try {
      overrideUA = pref.getCharPref("general.useragent.override");
    } catch(ex) {} // there is no pref set -> default UserAgent
    // Iterate over all menu items, but the first three [0/1/2] and 
    // select one by setting the 'checked' attribute
    for (var i = 6; i < aParent.childNodes.length; i++) { // var i = 4
      var menuLabel = aParent.childNodes[i].getAttribute("label");
      if (menuLabel == navigator.userAgent) {
        aParent.childNodes[i].setAttribute("checked", "true");
        override = true;
        break; // UA selected so bail out early!
      }
    }
    if (override) // Did we find the current HTTP userAgent in the menu?
      aParent.childNodes[2].removeAttribute("disabled");
    else if (overrideUA) { // This should only happen after poked around in pref files!
      aParent.childNodes[2].removeAttribute("disabled");
      // We automatically add new useragents to multizilla.rdf
      var RDFC = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
      var useragents = RDFC.MakeSeq(mzRDFStore, RDF.GetResource("urn:useragent-data"));
      if (useragents) {
        useragents.InsertElementAt(RDF.GetLiteral(navigator.userAgent), 1, true);
        mzRDFStore.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
        // Rebuild template, or this new item won't be on top
        aParent.builder.rebuild();
		// And select this new item
	    aParent.childNodes[6].setAttribute("checked", "true"); // 4
      }
    }
    else {
      aParent.childNodes[2].setAttribute("disabled", "true");
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function setUserAgentOverride(aEvent)
{
  var menuItemID = aEvent.getAttribute("id");

  if (!/quickpref-/.test(menuItemID)) {
    var userAgent = aEvent.getAttribute("label");
    if (userAgent)
      writePref("char", "general.useragent.override", userAgent);
  }
  else {
    writePref("char", "general.useragent.override", "");
    pref.clearUserPref("general.useragent.override");
  }
  loadURI("about:");
}
////////////////////////////////////////////////////////////////////////////////
function initRefSpoofingMenu(aElement)
{
  var refSetting = -1;
  var spoofURL = "http://ref.spoof.org/refspoof.cgi"; // default fake referrer
  var aWindow = gBrowser.contentWindow;
  var aDocument = aWindow.document;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  try { 
    refSetting = pref.getIntPref("network.http.sendRefererHeader");
  } catch (ex) {
  }
  for (var i = 0; i < aElement.childNodes.length; i++) {
    aElement.childNodes[i].setAttribute("disabled", (refSetting == 0) ? "true" : "false");
    aElement.childNodes[i].setAttribute("checked", "false");
  }
  try {
    spoofURL = readMyPref("multizilla.refspoof.spoofurl", "string", spoofURL);
  } catch (ex) {
  }
  aElement.childNodes[6].setAttribute("label", qpmBundle.GetStringFromName("fake.label") + " " + spoofURL);
  aElement.childNodes[7].setAttribute("label", aDocument.referrer ?  
                                               qpmBundle.GetStringFromName("currentRef.label") + " " + aDocument.referrer : 
                                               qpmBundle.GetStringFromName("noRef.label"));

  if (refSetting)
    initGroupPref(aElement);
}
////////////////////////////////////////////////////////////////////////////////
function displayWarn(messageNumber)
{
  var msg = null;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");

  switch(messageNumber) {
    case 0: msg = qpmBundle.GetStringFromName("refSpooferDisabled");
      break;
    case 1: msg = qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
    case 2: msg = qpmBundle.GetStringFromName("refSpooferNone");
      break;
    case 3: msg = qpmBundle.GetStringFromName("illegalFakeReferrer");
      break;
    case 4:
    case 5: var spoofer = readMyPref("multizilla.refspoof.spoofing", "int", 1);
            msg = (spoofer == 1) ? qpmBundle.GetStringFromName("refSpooferDisabled") : qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
  }
  if (msg)
    alert(msg);
}
////////////////////////////////////////////////////////////////////////////////
function manageFakeReferrer()
{
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var dialogTitle = qpmBundle.GetStringFromName("fakeReferrerDialogTitle");
  var dialogText = qpmBundle.GetStringFromName("fakeReferrerDialogText");
  var fakeRefIsText = qpmBundle.GetStringFromName("fakeRefIsSetTo");
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  var fakeReferrer = readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
  var result = {value:fakeReferrer};

  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  var ret = promptService.prompt(window, dialogTitle, dialogText, result, null, {value:0});

  if (ret && result.value && result.value != "") {
    alert(fakeRefIsText+result.value);
    writePref("string", "multizilla.refspoof.spoofurl", result.value);
  }
  else
    displayWarn(3);
}
////////////////////////////////////////////////////////////////////////////////
function openMZPrefWindow(aPanelID)
{
  aPanelID = aPanelID || "multiviews.xul";
  goPreferences(aPanelID, "chrome://multiviews/content/pref/pref-multiviews.xul", "multiviews");
}
////////////////////////////////////////////////////////////////////////////////
function openPrefEditor()
{
  gBrowser.selectedTab = gBrowser.addTab("chrome://global/content/config.xul"); 
  gBrowser.userTypedValue = ""; 
  SetPageProxyState("invalid", null);
}
////////////////////////////////////////////////////////////////////////////////
function onQPMClick(aEvent, aPopupID)
{
  if (aEvent.button == 0) {
    var i, menuitems;
    var popupNode = document.getElementById("quickpref-popup");

    if (aEvent.altKey) {
      openPrefEditor();
      return false;
    }
    else if (aEvent.metaKey || aEvent.ctrlKey) {
      var cachePopupNode = document.getElementById("quickpref-clearCachePopup");
      cachePopupNode.showPopup(cachePopupNode, aEvent.clientX, aEvent.clientY, "popup");
      return true;
    }
    else if (aEvent.shiftKey) {
      menuitems = popupNode.getElementsByAttribute("display", "menu");
      for (i = 0 ; i < menuitems.length; i++)
        menuitems[i].setAttribute("hidden", "true");
      popupNode.showPopup(popupNode, aEvent.clientX, aEvent.clientY, "popup");
      return false;
    }
    menuitems = popupNode.getElementsByAttribute("display", "menu");
    for (i = 0 ; i < menuitems.length; i++)
      menuitems[i].removeAttribute("hidden");
    popupNode.showPopup(popupNode, aEvent.clientX, aEvent.clientY, "popup");
	return true;
  }
  else if (aEvent.button == 1) 
    openMZPrefWindow();
  else if (aEvent.button == 2) {
    var context = aEvent.target.getAttribute("context");
    if (context) {
      var contextNode = document.getElementById(context);
      contextNode.showPopup(contextNode, aEvent.clientX, aEvent.clientY, "popup");
      return true;
    }
    else {
      askToDisableButton(aEvent);
      return true;
    }
  }
  return false;
}
////////////////////////////////////////////////////////////////////////////////
function mzTogglePackage(aEvent)
{
  var element = aEvent.originalTarget
  var packageName = element.getAttribute("packageName");
  var packageState = element.getAttribute("packageState");

  if (!packageState && packageName == "multiviews") {
    if (!confirmAction("confirmDialogTogglePackageTitle", "confirmDialogTogglePackageText"))
      return;
  }
  var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
  chromeRegistry.setAllowOverlaysForPackage(packageName.toLowerCase(), (packageState ? true: false));

  if (packageName == "multiviews")
    packageName = "MultiZilla";

  packageState = packageState ? 'enabled' : 'disabled';
  packageState = mzGetTextFromBundle(packageState, null, 'quickPrefsMenu.properties');
  var extensionMsg = mzGetTextFromBundle('extManagerMsg', [packageState], 'quickPrefsMenu.properties');
  alert('"'+packageName+'" '+extensionMsg);
}

//////////////////////////////////////////////////////////////////////////
// It is time to group the following functions into one javascript 'class'
//////////////////////////////////////////////////////////////////////////
function confirmAction(titlePtr, textPtr)
{
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var aDialogTitle = qpmBundle.GetStringFromName(titlePtr) || titlePtr;
  var aDialogText = qpmBundle.GetStringFromName(textPtr) || textPtr;
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  return promptService.confirm(window, aDialogTitle, aDialogText);
}
//////////////////////////////////////////////////////////////////////////
function clearDiskMemCache()
{
  clearCache("BOTH");
}
////////////////////////////////////////////////////////////////////////////////
function clearAllBackTraces()
{
  clearGlobalHistory();
  clearUrlBarHistory();
  clearCache("BOTH");
}
////////////////////////////////////////////////////////////////////////////////
function clearGlobalHistory()
{
  var globalHistory = Components.classes["@mozilla.org/browser/global-history;1"].getService(Components.interfaces.nsIBrowserHistory);
  globalHistory.removeAllPages();
}
////////////////////////////////////////////////////////////////////////////////
function clearUrlBarHistory()
{
  var urlBarHistory = Components.classes["@mozilla.org/browser/urlbarhistory;1"].getService(Components.interfaces.nsIUrlbarHistory);
  urlBarHistory.clearHistory();
}
////////////////////////////////////////////////////////////////////////////////
// This function can be used to clear stored data for disk and/or mememory cache
////////////////////////////////////////////////////////////////////////////////
function clearCache(aCacheType)
{
  var classID = Components.classes["@mozilla.org/network/cache-service;1"];
  var cacheService = classID.getService(Components.interfaces.nsICacheService);

  if (aCacheType == "DISK")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  else if (aCacheType == "MEMORY")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
  else { // "BOTH"
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
  }
}
////////////////////////////////////////////////////////////////////////////////
function mzClearAllCookies()
{
  const cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
                                  .getService(Components.interfaces.nsICookieManager);
  if (cookieManager)
    cookieManager.removeAll();
}
////////////////////////////////////////////////////////////////////////////////
// This clears all saved passwords. This is a serious action (dataloss at risk) 
// so we require the users confirmation, before doing anything. There's also a 
// pref "wallet.crypto" that can be used to encrypt sensitive data (passwords)
// But, we don't have to check this pref, because mozilla will take care of it!
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/netwerk/base/public/nsIPasswordManager.idl
function mzClearAllPasswords()
{
  passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);

  var container = passwordManager.enumerator;
  var items = [];
  while (container.hasMoreElements()) {
    var item = container.getNext().QueryInterface(Components.interfaces.nsIPassword);
    items.push(item);
  }
  for (var i = 0; i < items.length; ++i)
    passwordManager.removeUser(items[i].host, items[i].user);
}
////////////////////////////////////////////////////////////////////////////////
// This removes all references from downloads.rdf. It took me quite some time, 
// but thanks to Neil, for the Start/EndBatchUpdate lines, this now also works.
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/xpfe/components/download-manager/public/nsIDownloadManager.idl
function mzClearAllDownloads()
{
  var downloadManager = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
  // Construct the datasource from the filename, because I can't find it in the source!
  var datasource = getNewOrCurrentDSByFilename("downloads.rdf", false, null);
  var downloads = mzConstructRDFContainer(datasource, "seq", "NC:DownloadsRoot", false).GetElements(); 
  var downloadQueue = new Array();

  while (downloads.hasMoreElements()) {
    var item = downloads.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    downloadQueue.push(item);
  }
  downloadManager.startBatchUpdate();
  for (var i = 0; i < downloadQueue.length; i++) {
    try {
      downloadManager.removeDownload(downloadQueue[i].Value);
    } catch(ex) {
      dump("\nmzClearAllDownloads() failed to remove download data!");
    }
  }
  downloadManager.endBatchUpdate();
}
////////////////////////////////////////////////////////////////////////////////
// This should remove all form related data.
////////////////////////////////////////////////////////////////////////////////
// http://lxr.mozilla.org/seamonkey/source/extensions/wallet/signonviewer/nsISignonViewer.idl
// http://lxr.mozilla.org/seamonkey/source/extensions/wallet/public/nsIWalletService.idl
// chrome://communicator/content/wallet/WalletViewer.xul   Menu/Tools/Fill In Form
// chrome://communicator/content/wallet/WalletPreview.xul  Menu/Tools/Edit Form
// chrome://communicator/content/wallet/SignonViewer.xul   Menu/Tools/Form Manager
function mzClearAllFormData() 
{
  const walletViewerInterface = Components.classes["@mozilla.org/walleteditor/walleteditor-world;1"].createInstance(Components.interfaces.nsIWalletEditor);
  var list = walletViewerInterface.GetValue();

  if (list.length > 0) { // no data available or database locked!
    var BREAK = list[0];
    walletViewerInterface.SetValue("OK" + BREAK, window);
  }
}
////////////////////////////////////////////////////////////////////////////////
// This removes all locally stored data, including passwords so be very careful!
////////////////////////////////////////////////////////////////////////////////
function mzClearAllLocalData()
{
  /***
  * This can be used to clear all passwords and form data!
  * walletServiceInterface = Components.classes['@mozilla.org/wallet/wallet-service;1'].getService(Components.interfaces.nsIWalletService);
  * walletServiceInterface.WALLET_DeleteAll(); 
  */
  clearCache("ALL");
  clearUrlBarHistory()
  clearGlobalHistory();
  mzClearAllCookies();
  mzClearAllDownloads();
  mzClearAllFormData();
  mzClearAllPasswords();
}
////////////////////////////////////////////////////////////////////////////////
function openUserAgentManager(aEvent)
{
  if (aEvent)
    aEvent.preventBubble();
  window.openDialog("chrome://multiviews/content/multiviewsUserAgentManager.xul", 
                    "privacy-dialog", "chrome,dialog,dependent,resizable");
}

